searchNodes=[{"doc":"Sqlcx gives you a way to create and query SQLCipher (encrypted SQLite) databases.Basic Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.exec(db, &quot;CREATE TABLE t (a INTEGER, b INTEGER, c INTEGER)&quot;) :ok iex&gt; Sqlcx.exec(db, &quot;INSERT INTO t VALUES (1, 2, 3), (4, 5, 6)&quot;) :ok iex&gt; Sqlcx.query(db, &quot;SELECT * FROM t&quot;) {:ok, [[1, 2, 3], [4, 5, 6]]} iex&gt; Sqlcx.query_rows(db, &quot;SELECT * FROM t&quot;) {:ok, [%{a: 1, b: 2, c: 3}, %{a: 4, b: 5, c: 6}]} ConfigurationSqlcx uses the Erlang library esqlcipher which accepts a timeout parameter for almost all interactions with the database. The default value for this timeout is 5000 ms. Many functions in Sqlcx accept a :db_timeout option that is passed on to the esqlcipher calls and also defaults to 5000 ms. If required, this default value can be overridden globally with the following in your config.exs:config :sqlcx, db_timeout: 10_000 # or other positive integer number of msAnother esqlcipher parameter is :db_chunk_size. This is the number of rows that are read from native sqlcipher and send to the Erlang process in one bulk. For example, consider a table mytable that has 1000 rows. We make the query to get all rows with db_chunk_size: 500 parameter:Sqlcx.query(db, &quot;select * from mytable&quot;, db_chunk_size: 500)In this case, all rows will be passed from native sqlcipher OS thread to the Erlang process in two passes with each pass containing 500 rows. This reduces the overhead of transmitting and copying rows from the native OS sqlcipher thread to the Erlang process by chunking the list of result rows. There will be no difference visible to the end user: The result of the Sqlcx.query call will be the same no matter the chunk size. Please decrease :db_chunk_size if rows are heavy. The default value is 5000. If you’re in doubt what to do with this parameter, just leave it as is. The default value will be ok in almost all cases. You can also change the default value like this:config :sqlcx, db_chunk_size: 500 # if most of the database rows are heavy","ref":"Sqlcx.html","title":"Sqlcx","type":"module"},{"doc":"Return the number of the rows that have been modified, inserted, or deleted by the last statement.See https://www.sqlite.org/c3ref/changes.html for details information.Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.exec(db, &quot;create table test (val integer)&quot;) :ok iex&gt; Sqlcx.exec(db, &quot;insert into test(val) values (1), (2)&quot;) :ok iex&gt; Sqlcx.changes(db) 2","ref":"Sqlcx.html#changes/2","title":"Sqlcx.changes/2","type":"function"},{"doc":"Close the database connection.","ref":"Sqlcx.html#close/2","title":"Sqlcx.close/2","type":"function"},{"doc":"Send a raw SQL statement to the database.This function is intended for running simple/one-off SQL statements.Parameters are not supported here, see query/3 related functions for those! No results are returned; queries return either :ok or an error.This is generally useful for things like re-playing a SQL export back into the database or for simple commands like BEGIN or COMMIT (but see also with_transaction/3 and with_savepoint/4 for transactions).Do not manually insert values into SQL statements as that is prone to SQL injection. If you need the results returned by a query, use the Sqlcx.Query interface (see also the query/3 and query_rows/3 shortcuts) or work directly with prepared statements using Sqlcx.Statement.","ref":"Sqlcx.html#exec/3","title":"Sqlcx.exec/3","type":"function"},{"doc":"Same as exec/3 but raises a Sqlcx.QueryError on error. Returns :ok otherwise.","ref":"Sqlcx.html#exec!/3","title":"Sqlcx.exec!/3","type":"function"},{"doc":"Whether conn is a database connection. Can be used in guards.","ref":"Sqlcx.html#is_db/1","title":"Sqlcx.is_db/1","type":"macro"},{"doc":"Whether conn is a connection to an encrypted database. Can be used in guards.","ref":"Sqlcx.html#is_encrypted/1","title":"Sqlcx.is_encrypted/1","type":"macro"},{"doc":"Whether conn is a connection to an unencrypted/plaintext database. Can be used in guards.","ref":"Sqlcx.html#is_plaintext/1","title":"Sqlcx.is_plaintext/1","type":"macro"},{"doc":"Open an sqlite3/sqlcipher database connection that can be queried. If the database file does not yet exist, it will be created.Pass [db_password: &quot;1234&quot;] as an options to open an sqlcipher encrypted database. If the database does not exist, an encrypted database will be created on first write. The actual encryption key will be derived from db_password using PBKDF2 key derivation by sqlcipher. However, it's possible to specify a raw byte sequence as a key using [db_password: {:raw, &lt;&lt;...&gt;&gt;}]. The raw key has to be either 32 or 48 bytes long where the key is 32 bytes and the optional salt is another 16 bytes long. If the salt is not explicitly provided, it will be generated randomly and stored in the first 16 bytes of the database. The raw binary key will be internally hex-encoded and passed to sqlcipher as x'A0B1C2(...)D3E4F5' with either 64 or 96 hex chaarcters. In order to avoid confusion or unsafe behavior, string passwords of that format will return an {:error, {:badarg, _}}.Please refer to the sqlcipher documentation for further information about the generation and usage of encryption keys. Note that opening encrypted databases can take quite some time. This is by design because key derivation uses the PBKDF2 algorithm. If on a slower machine, adjust the timeout accordingly.Returns {:ok, db} where db is a database connection if the file could be opened or created and could be read (i.e., the db_password was correct or the database is not encrypted).If the password is incorrect or a password was given on an unencrypted database (or vice versa), or if the file is corrupted or unreadable, will return an error of the form {:error, {:baddb, _}}.Remember to close/2 the database connection when it is no longer needed (although it will automatically be closed when its process dies or it is garbage collected)","ref":"Sqlcx.html#open/2","title":"Sqlcx.open/2","type":"function"},{"doc":"Shortcut for open/2, raises errors instead of returning error tuples.","ref":"Sqlcx.html#open!/2","title":"Sqlcx.open!/2","type":"function"},{"doc":"Runs a query and returns the results.Parametersdb - An SQLCipher database connection.sql - The query to run as a string.opts - Options to pass into the query. See below for details.Optionsbind - List/keyword list of values to bind to the sqlite parameters. See Statement.bind/3 for details.into - The collection to put each row into. If provided, values are ziped with the column names, so into: %{} produces a Map (note that column names are Strings, not atoms). Defaults to nil which simply outputs each row as a list of values without any column names.db_timeout - The timeout (in ms) to apply to each of the underlying SQLCipher operations. Defaults to Application.get_env(:sqlcx, :db_timeout) or 5000 ms if not configured.db_chunk_size - The number of rows to read from native sqlite and send to erlang process in one bulk. Defaults to Application.get_env(:sqlcx, :db_chunk_size) or 5000 if not configured.Returns{:ok, [[values...]...]} on success{:error, _} on failure.Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.exec(db, &quot;CREATE TABLE data (cat, name)&quot;) :ok iex&gt; Sqlcx.exec(db, &quot;INSERT INTO data VALUES (1, &#39;a&#39;), (2, &#39;b&#39;), (2, &#39;c&#39;)&quot;) :ok iex&gt; Sqlcx.query(db, &quot;SELECT * FROM data WHERE cat = :cat&quot;, bind: [cat: 2]) {:ok, [[2, &quot;b&quot;], [2, &quot;c&quot;]]} iex&gt; Sqlcx.query(db, &quot;SELECT * FROM data WHERE cat = :cat&quot;, bind: [cat: 2], into: []) {:ok, [[{&quot;cat&quot;, 2}, {&quot;name&quot;, &quot;b&quot;}], [{&quot;cat&quot;, 2}, {&quot;name&quot;, &quot;c&quot;}]]} iex&gt; Sqlcx.query(db, &quot;SELECT * FROM data WHERE cat = :cat&quot;, bind: [cat: 2], into: %{}) {:ok, [%{&quot;cat&quot; =&gt; 2, &quot;name&quot; =&gt; &quot;b&quot;}, %{&quot;cat&quot; =&gt; 2, &quot;name&quot; =&gt; &quot;c&quot;}]} iex&gt; Sqlcx.close(db) :ok","ref":"Sqlcx.html#query/3","title":"Sqlcx.query/3","type":"function"},{"doc":"Same as query/3 but raises a Sqlcx.QueryError on error.Returns the results otherwise.","ref":"Sqlcx.html#query!/3","title":"Sqlcx.query!/3","type":"function"},{"doc":"Runs a query and returns the results as a list of rows each represented as a map.Unlike query/3, column names are translated into atoms and rows are Maps so values can be accessed idiomatically using a row.value syntax.Questioning: This function might be dropped in future versions.Parametersdb - An SQLCipher database.sql - The query to run as a string.opts - Options to pass into the query. See below for details.Optionsbind - List/keyword list of values to bind to the sqlite parameters. See Statement.bind/3 for details.into - The collection to put each row into. Use [] to get keyword lists. Defaults to %{}.db_timeout - The timeout (in ms) to apply to each of the underlying SQLCipher operations. Defaults to Application.get_env(:sqlcx, :db_timeout) or 5000 ms if not configured.db_chunk_size - The number of rows to read from native sqlite and send to erlang process in one bulk. Defaults to Application.get_env(:sqlcx, :db_chunk_size) or 5000 if not configured.Returns{:ok, [%{name: value}]} on success{:error, _} on failure.Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.exec(db, &quot;CREATE TABLE data (cat, name)&quot;) :ok iex&gt; Sqlcx.exec(db, &quot;INSERT INTO data VALUES (1, &#39;a&#39;), (2, &#39;b&#39;), (2, &#39;c&#39;)&quot;) :ok iex&gt; Sqlcx.query_rows(db, &quot;SELECT * FROM data WHERE cat = :cat&quot;, bind: [cat: 2]) {:ok, [%{cat: 2, name: &quot;b&quot;}, %{cat: 2, name: &quot;c&quot;}]} iex&gt; Sqlcx.query_rows(db, &quot;SELECT * FROM data WHERE cat = :cat&quot;, bind: [cat: 2], into: []) {:ok, [[cat: 2, name: &quot;b&quot;], [cat: 2, name: &quot;c&quot;]]} iex&gt; Sqlcx.close(db) :ok","ref":"Sqlcx.html#query_rows/3","title":"Sqlcx.query_rows/3","type":"function"},{"doc":"Same as query_rows/3 but raises a Sqlcx.QueryError on error.Returns the results otherwise.","ref":"Sqlcx.html#query_rows!/3","title":"Sqlcx.query_rows!/3","type":"function"},{"doc":"Change the password of an encrypted database.password can either be a String or a {:raw, &lt;&lt;...&gt;&gt;} tuple containing a binary raw key. See open/2.Note that this function cannot be used to encrypt an unencrypted database.Returns :ok or an error/0 if the new key is invalid or rekeying the database fails.","ref":"Sqlcx.html#rekey/3","title":"Sqlcx.rekey/3","type":"function"},{"doc":"Shortcut for rekey/3, raises errors instead of returning error tuples.","ref":"Sqlcx.html#rekey!/3","title":"Sqlcx.rekey!/3","type":"function"},{"doc":"Run a code block inside a SAVEPOINT transaction. Unlike regular BEGIN/COMMIT transactions, savepoints can be nested.If the do block returns without raising an exception, the savepoint will be commited via RELEASE SAVEPOINT. Otherwise, ROLLBACK TO SAVEPOINT will be called. Even if an inner savepoint is committed, it may be rolled back if an outer transaction is rolled back.Since this is implemented as a macro, Sqlcx must be required or imported in order to use it. See also the with_savepoint/3 version which takes a function as an argument.Note that this version does not take any further arguments. Thus, the savepoint will be automatically given a random name and the default timeout will be applied to the SAVEPOINT, RELEASE and ROLLBACK commands.Returns {:ok, result} if the function succeeds, {:exception, err} if the function raises an exception, {:error, err} if any of the savepoint sqlite commands fails.Examplesiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.savepoint db do ...&gt; Sqlcx.exec(db, &quot;create table foo(id integer)&quot;) ...&gt; Sqlcx.exec(db, &quot;insert into foo (id) values(42)&quot;) ...&gt; try do ...&gt; Sqlcx.savepoint db do ...&gt; Sqlcx.exec(db, &quot;insert into foo (id) values (3)&quot;) ...&gt; :ok = Sqlcx.exec(db, &quot;not a valid sql query&quot;) # Raises an exception ...&gt; end # will be rolled back because the do block fails ...&gt; rescue ...&gt; _ -&gt; &quot;we don&#39;t care about the exception&quot; ...&gt; end ...&gt; end iex&gt; Sqlcx.query_rows(db, &quot;select * from foo&quot;) {:ok, [%{id: 42}]}","ref":"Sqlcx.html#savepoint/2","title":"Sqlcx.savepoint/2","type":"macro"},{"doc":"Sets a PID to receive notifications about table updates.Messages will come in the shape of: {action, table, rowid}action: either :insert, :update, or :deletetable: charlist of the table name. Example: 'posts'rowid: internal rowid index of the row. If the table contains an INTEGER PRIMARY KEY column, this column will be the row id. Do note that INT PRIMARY KEY and similar will not be an alias for the row id.Also note that update hooks do not work on WITHOUT ROWID tables.See the sqlite3 docs for update_hook and for row ids.","ref":"Sqlcx.html#set_update_hook/3","title":"Sqlcx.set_update_hook/3","type":"function"},{"doc":"Run a code block inside a transaction. If the do block does not raise an exception, the transaction will be commited via COMMIT. Otherwise, ROLLBACK will be called.Note that transactions cannot be nested. If you need nested transactions, use savepoint/2.Since this is implemented as a macro, Sqlcx must be required or imported in order to use it. See also the with_transaction/3 version which takes a function as an argument.Note that this version does not take any further arguments. The default timeout will be applied to the BEGIN, COMMIT and ROLLBACK commands.Returns the result of the function if it function succeeds. Any errors or exceptions are reraised, and errors in the transaction SQL commands raise an exception as well.Examplesiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.transaction db do ...&gt; Sqlcx.exec(db, &quot;create table foo(id integer)&quot;) ...&gt; Sqlcx.exec(db, &quot;insert into foo (id) values(42)&quot;) ...&gt; end iex&gt; Sqlcx.query_rows(db, &quot;select * from foo&quot;) {:ok, [%{id: 42}]}","ref":"Sqlcx.html#transaction/2","title":"Sqlcx.transaction/2","type":"macro"},{"doc":"Opens a database connection, executes fun on it and closes it.Returns an {:ok, result} tuple containing the return value of fun or an error/0 tuple if an error occurs while opening the database connection. Note that errors raised by fun will remain raised and will not be converted to an error tuple.","ref":"Sqlcx.html#with_db/3","title":"Sqlcx.with_db/3","type":"function"},{"doc":"Opens a database connection, executes fun on it and closes it.Returns the result of fun or raises an error if the opening the database fails.","ref":"Sqlcx.html#with_db!/3","title":"Sqlcx.with_db!/3","type":"function"},{"doc":"Runs fun inside a SAVEPOINT transaction. Unlike regular BEGIN/COMMIT transactions, savepoints can be nested.fun will be called with the database connection as its first argument. Use the args option to pass a list of further arguments if needed.If fun returns without raising an exception, the savepoint will be commited via RELEASE SAVEPOINT. Otherwise, ROLLBACK TO SAVEPOINT will be called. Even if an inner savepoint is committed, it may be rolled back if an outer transaction is rolled back.By default, a random savepoint name is automatically generated. Pass a name option to set your own savepoint name. Be careful with the naming of savepoints, unexpected things might happen if you nest savepoints of the same name. The name is also not escaped in the SQL commands, so it should only use alphanumeric characters.See also the sqlite3 docs about savepointsReturns the result of fun if the function succeeds. If any exceptions are raised or values are thrown, the savepoint transaction will be rolled back and the exception will be reraised or the value rethrown. This implies that if you nest savepoint transactions, unless you rescue/catch the exception, the outer transaction will also be rolled back because an exception has been raisedExamplesiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.with_savepoint(db, fn(db, value) -&gt; ...&gt; Sqlcx.exec(db, &quot;create table foo (id integer)&quot;) ...&gt; {:ok, _} = Sqlcx.query(db, &quot;insert into foo (id) values (?)&quot;, bind: [value]) ...&gt; try do ...&gt; Sqlcx.with_savepoint(db, fn(db) -&gt; ...&gt; Sqlcx.exec(db, &quot;insert into foo (id) values (3)&quot;) ...&gt; :ok = Sqlcx.exec(db, &quot;not a valid sql query&quot;) # Raises an exception ...&gt; end) # will be rolled back because the function fails ...&gt; rescue ...&gt; _ -&gt; &quot;we don&#39;t care about the exception&quot; ...&gt; end ...&gt; end, [args: [42]]) iex&gt; Sqlcx.query_rows(db, &quot;select * from foo&quot;) {:ok, [%{id: 42}]}","ref":"Sqlcx.html#with_savepoint/3","title":"Sqlcx.with_savepoint/3","type":"function"},{"doc":"Runs fun inside a transaction. If fun returns without raising an exception, the transaction will be commited via COMMIT. Otherwise, ROLLBACK will be called.fun will be called with the database connection as its first argument. Use the args option to pass a list of further arguments if needed.Note that transactions cannot be nested. Prefer with_savepoint/3 which also allows nested transactions.See also the transaction/2 version which takes a code block.Returns the result of the function if it function succeeds. Any errors or exceptions are reraised, and errors in the transaction SQL commands raise an exception as well.Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.with_transaction(db, fn(db, val) -&gt; ...&gt; Sqlcx.exec(db, &quot;create table foo(id integer)&quot;) ...&gt; {:ok, _} = Sqlcx.query(db, &quot;insert into foo (id) values(:value)&quot;, bind: [value: val]) ...&gt; end, [args: [42]]) iex&gt; Sqlcx.query_rows(db, &quot;select * from foo&quot;) {:ok, [%{id: 42}]}","ref":"Sqlcx.html#with_transaction/3","title":"Sqlcx.with_transaction/3","type":"function"},{"doc":"Database connection to an encrypted or unencrypted database.","ref":"Sqlcx.html#t:connection/0","title":"Sqlcx.connection/0","type":"opaque"},{"doc":"Database connection to an encrypted database., subtype of connection()","ref":"Sqlcx.html#t:encrypted_connection/0","title":"Sqlcx.encrypted_connection/0","type":"opaque"},{"doc":"An error that can be returned by sqlcipher calls. Contains an error type atom and a reason string.","ref":"Sqlcx.html#t:error/0","title":"Sqlcx.error/0","type":"type"},{"doc":"Options that can be passed to open/2 or open!/2 for encrypted databases.","ref":"Sqlcx.html#t:open_encrypted_options/0","title":"Sqlcx.open_encrypted_options/0","type":"type"},{"doc":"Options that can be passed to open/2, open!/2, or with_db/3.","ref":"Sqlcx.html#t:open_options/0","title":"Sqlcx.open_options/0","type":"type"},{"doc":"Options that can be passed to open/2 or open!/2 for unencrypted databases.","ref":"Sqlcx.html#t:open_plaintext_options/0","title":"Sqlcx.open_plaintext_options/0","type":"type"},{"doc":"Database password","ref":"Sqlcx.html#t:password/0","title":"Sqlcx.password/0","type":"type"},{"doc":"Database connection to an unencrypted database, subtype of connection()","ref":"Sqlcx.html#t:plaintext_connection/0","title":"Sqlcx.plaintext_connection/0","type":"opaque"},{"doc":"Options that can be passed to the query functions.","ref":"Sqlcx.html#t:query_options/0","title":"Sqlcx.query_options/0","type":"type"},{"doc":"Sqlcx.Server provides a GenServer to wrap an sqlcipher db. This makes it easy to share a SQLCipher database between multiple processes without worrying about concurrency issues (although sqlite handles concurrency natively as well). You can also register the process with a name so you can query by name later.Unsupervised Exampleiex&gt; {:ok, pid} = Sqlcx.Server.start_link(&quot;:memory:&quot;, [name: :example]) iex&gt; Sqlcx.Server.exec(pid, &quot;CREATE TABLE t (a INTEGER, b INTEGER)&quot;) :ok iex&gt; Sqlcx.Server.exec(pid, &quot;INSERT INTO t (a, b) VALUES (1, 1), (2, 2), (3, 3)&quot;) :ok iex&gt; Sqlcx.Server.query(pid, &quot;SELECT * FROM t WHERE b = 2&quot;) {:ok, [[2, 2]]} iex&gt; Sqlcx.Server.query(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 1&quot;, into: %{}) {:ok, [%{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 1}]} iex&gt; Sqlcx.Server.query_rows(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 2&quot;) {:ok, [%{a: 1, b: 1}, %{a: 2, b: 2}]} iex&gt; Sqlcx.Server.prepare(:example, &quot;SELECT * FROM t&quot;) {:ok, %{column_names: [&quot;a&quot;, &quot;b&quot;], column_types: [&quot;INTEGER&quot;, &quot;INTEGER&quot;]}} # Subsequent queries using this exact statement will now operate more efficiently # because this statement has been cached. iex&gt; Sqlcx.Server.prepare(:example, &quot;INVALID SQL&quot;) {:error, {:sqlite_error, &#39;near &quot;INVALID&quot;: syntax error&#39;}} iex&gt; Sqlcx.Server.stop(:example) :ok iex&gt; :timer.sleep(10) # wait for the process to exit asynchronously iex&gt; Process.alive?(pid) false Supervised Exampleimport Supervisor.Spec children = [ worker(Sqlcx.Server, [&quot;priv/my_db.db&quot;, [name: :my_db]) ] Supervisor.start_link(children, strategy: :one_for_one)","ref":"Sqlcx.Server.html","title":"Sqlcx.Server","type":"module"},{"doc":"Same as Sqlcx.changes/2 but using the shared db connection saved in the GenServer state.Returns the results of Sqlcx.changes/2.","ref":"Sqlcx.Server.html#changes/2","title":"Sqlcx.Server.changes/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Sqlcx.Server.html#child_spec/1","title":"Sqlcx.Server.child_spec/1","type":"function"},{"doc":"Same as Sqlcx.exec/3 but using the shared db connection saved in the GenServer state.Returns the results of Sqlcx.exec/3.","ref":"Sqlcx.Server.html#exec/3","title":"Sqlcx.Server.exec/3","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Sqlcx.Server.html#init/1","title":"Sqlcx.Server.init/1","type":"function"},{"doc":"Prepares a SQL statement for future use.This causes a call to sqlite3_prepare_v2 to be executed in the Server process. To protect the reference to the corresponding sqlite3_stmt struct from misuse in other processes, that reference is not passed back. Instead, prepared statements are cached in the Server process. If a subsequent call to query/3 or query_rows/3 is made with a matching SQL statement, the prepared statement is reused.Prepared statements are purged from the cache when the cache exceeds a preset limit (32 statements by default).Note that binding parameters to a statement is only possible using query/3 or query_rows/3. These functions also use the cache, so a statement that has been prepared before will be run from the cache.Returns summary information about the prepared statement. {:ok, %{column_names: [&quot;foo&quot;, &quot;bar&quot;,... ], column_types: [&quot;INTEGER&quot;, ...]}} on success or {:error, {:id, 'message'}} if the statement could not be prepared.","ref":"Sqlcx.Server.html#prepare/3","title":"Sqlcx.Server.prepare/3","type":"function"},{"doc":"Same as Sqlcx.query/3 but using the shared db connection saved in the GenServer state.Returns the results of Sqlcx.query/3.","ref":"Sqlcx.Server.html#query/3","title":"Sqlcx.Server.query/3","type":"function"},{"doc":"Same as Sqlcx.query_rows/3 but using the shared db connection saved in the GenServer state.Returns the results of Sqlcx.query_rows/3.","ref":"Sqlcx.Server.html#query_rows/3","title":"Sqlcx.Server.query_rows/3","type":"function"},{"doc":"Change the password used to encrypt the database.","ref":"Sqlcx.Server.html#rekey/3","title":"Sqlcx.Server.rekey/3","type":"function"},{"doc":"Same as Sqlcx.set_update_hook/3 but using the shared db connection saved in the GenServer state.Returns the results of Sqlcx.set_update_hook/3.","ref":"Sqlcx.Server.html#set_update_hook/3","title":"Sqlcx.Server.set_update_hook/3","type":"function"},{"doc":"Starts a SQLCipher Server (GenServer) instance.In addition to the options that are typically provided to GenServer.start_link/3, you can also specify:db_password: optional password used for opening an encrypted database. See Sqlcx.open/2 for details.stmt_cache_size: to override the default limit (32) of statements that are cached when calling prepare/3.db_timeout: to override :esqlcipher's default timeout of 5000 ms for interactions with the database. This can also be set in config.exs as config :sqlcx, db_timeout: 5_000.db_chunk_size: to override :esqlcipher's default chunk_size of 5000 rows to read from native sqlite and send to erlang process in one bulk. This can also be set in config.exs as config :sqlcx, db_chunk_size: 5_000.","ref":"Sqlcx.Server.html#start_link/2","title":"Sqlcx.Server.start_link/2","type":"function"},{"doc":"Stops the server and closes the database connection.","ref":"Sqlcx.Server.html#stop/1","title":"Sqlcx.Server.stop/1","type":"function"},{"doc":"","ref":"Sqlcx.Server.html#t:init_options/0","title":"Sqlcx.Server.init_options/0","type":"type"},{"doc":"","ref":"Sqlcx.Server.html#t:query_options/0","title":"Sqlcx.Server.query_options/0","type":"type"},{"doc":"","ref":"Sqlcx.Server.html#t:server_id/0","title":"Sqlcx.Server.server_id/0","type":"type"},{"doc":"","ref":"Sqlcx.Server.html#t:server_options/0","title":"Sqlcx.Server.server_options/0","type":"type"},{"doc":"","ref":"Sqlcx.Server.html#t:state/0","title":"Sqlcx.Server.state/0","type":"type"},{"doc":"","ref":"Sqlcx.Server.html#t:timeout_options/0","title":"Sqlcx.Server.timeout_options/0","type":"type"},{"doc":"Implements a least-recently used (LRU) cache for prepared SQLite statements.Caches a fixed number of prepared statements and purges the statements which were least-recently used when that limit is exceeded.","ref":"Sqlcx.Server.StatementCache.html","title":"Sqlcx.Server.StatementCache","type":"module"},{"doc":"Creates a new prepared statement cache.","ref":"Sqlcx.Server.StatementCache.html#new/2","title":"Sqlcx.Server.StatementCache.new/2","type":"function"},{"doc":"Given a statement cache and an SQL statement (string), returns a tuple containing the updated statement cache and a prepared SQL statement.If possible, reuses an existing prepared statement. If not, prepares the statement and adds it to the cache, possibly removing the least-recently used prepared statement if the designated cache size limit would be exceeded.Will return {:error, reason} if SQLite is unable to prepare the statement.","ref":"Sqlcx.Server.StatementCache.html#prepare/3","title":"Sqlcx.Server.StatementCache.prepare/3","type":"function"},{"doc":"","ref":"Sqlcx.Server.StatementCache.html#t:t/0","title":"Sqlcx.Server.StatementCache.t/0","type":"type"},{"doc":"Provides an interface for working with SQLite prepared statements.Care should be taken when using prepared statements directly – they are not immutable objects like most things in Elixir. Statements have internal states in sqlite3/sqlcipher, such as bound arguments and returned rows. For instance, if you call fetch_one/2 multiple times, the next row will be returned each time, not the same one for all calls. Thus, sharing a statement between different processes can cause problems if the processes accidentally interleave operations on the statement. It's a good idea to create different statements per process, or to wrap the statements up in a GenServer to prevent interleaving operations.See bind/3 for allowed parameter formats.Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.query(db, &quot;CREATE TABLE data (id, name);&quot;) {:ok, []} iex&gt; {:ok, statement} = Sqlcx.Statement.prepare(db, &quot;INSERT INTO data VALUES (?, ?);&quot;) iex&gt; Sqlcx.Statement.bind(statement, [1, &quot;hello&quot;]) iex&gt; Sqlcx.Statement.exec(statement) :ok iex&gt; {:ok, statement} = Sqlcx.Statement.prepare(db, &quot;SELECT * FROM data;&quot;) iex&gt; Sqlcx.Statement.fetch_all(statement, db_timeout: 1_000) {:ok, [[1, &quot;hello&quot;]]} iex&gt; Sqlcx.close(db) :okRETURNING Clause SupportSince version 3.35.0, SQLite natively support the RETURNING extension to INSERT, DELETE, and UPDATE commands required by Ecto (see https://www.sqlite.org/lang_returning.html). Thus, we were able to drop the previous workaround.","ref":"Sqlcx.Statement.html","title":"Sqlcx.Statement","type":"module"},{"doc":"Binds values to a prepared statement.All forms of parameters in SQL statements supported by sqlite3 are supported (see also sqlite3 docs):?: Unnamed/anonymous parameters (these will implicitly be assigned a number that is the previously largest assigned number + 1; numbering begins at 1),?NNN, where 1 ≤ NNN ≤ 32766: Numbered parameters, and:AAA, where AAA is an alphanumeric identifier (e.g., :my_param_value). These will internally be assigned a number similarly to anonymous parameters, so do not mix named and numbered parameters or you will probably get unexpected results.NB: Sqlite3 also supports the forms @AAA and $AAA but since the initial character (@/$) is part of the name, you would actually need to pass {:&quot;@name&quot;, value} or {:&quot;$name&quot;, value}. {:name, value} is automatically interpreted as {:&quot;:name&quot;, value}, so the :AAA form should be preferred. Do not use $blob as a parameter name since {:&quot;$blob&quot;, _} tuples will be interpreted as the sqlite BLOB datatype. Do not use non-ASCII characters in parameter names.Anonymous parameters of the form ? are discouraged; prefer named or numbered parameters.ValuesAll sqlite3 data types are supported. The following values can be bound to a prepared statement:nil (aka :nil), which will be transformed to SQL NULLIntegers (integer/0)Floats (float/0)Strings (String.t/0): UTF-8-encoded strings of any lengthBlobs (binaries, binary/0): Use {:&quot;$blob&quot;, &lt;&lt;...&gt;&gt;} (or blob/1)Note that sqlite3 does not have a boolean data type. Use integers 0 and 1. Values are translated between Elixir and sqlite3 data types when binding or fetching. Trying to bind any other types, such as atoms or booleans, will result in an error. Also not that sqlite3 is dynamically typed, so a column may contain values of different types (and the declared column type doesn't actually matter).See also :esqlcipher.bind/3Function parametersbind/3 accepts the following arguments:statement - The statement to bind values into.values - A list of values to bind to the statement. The list can contain either anonymous values (e.g., [42, &quot;foo&quot;, nil]) or key–value tuples with numbers (e.g., [{1, 42}, {5, &quot;foo&quot;}]) or atoms as keys (e.g., [{:foo, 42}, {:bar, &quot;baz&quot;}], which is of course equivalent to [foo: 42, bar: &quot;baz&quot;]). These keys correspond to anonymous, numbered, or named parameters in SQL statements. These three types can but should not be mixed. If the values list contains anonymous values without keys, these are internally numbered similarly to the internal sqlite3 parameter numbering scheme described above (i.e., starting at 1).If a parameter from the SQL statement is missing in the value list, it will be silently bound as NULL.Also accepts the following keyword option:db_timeout – timeout in ms for the bind command to run. Defaults to 5000, or the :db_timeout application config value.Returns{:ok, statement} on success{:error, {type, reason}} for any errors (see Sqlcx.error/0).Unlike most Elixir objects, Sqlite3 statements are not immutable but have a state. The statement that this function returns is the exact same object as the statement parameter you pass as the first argument.","ref":"Sqlcx.Statement.html#bind/3","title":"Sqlcx.Statement.bind/3","type":"function"},{"doc":"Same as bind/3 but raises a Sqlcx.Statement.BindError on error.Returns the statement otherwise.","ref":"Sqlcx.Statement.html#bind!/3","title":"Sqlcx.Statement.bind!/3","type":"function"},{"doc":"Returns a {:&quot;$blob&quot;, data} tuple for use with bind/3","ref":"Sqlcx.Statement.html#blob/1","title":"Sqlcx.Statement.blob/1","type":"function"},{"doc":"Runs a statement that returns no results.Should be called after the statement has been bound.Parametersstatement - The statement to run.Also accepts the following keyword options:db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in application config.Returns:ok{:error, {type, reason}}","ref":"Sqlcx.Statement.html#exec/2","title":"Sqlcx.Statement.exec/2","type":"function"},{"doc":"Same as exec/2 but raises a Sqlcx.Statement.ExecError on error.Returns :ok otherwise.","ref":"Sqlcx.Statement.html#exec!/2","title":"Sqlcx.Statement.exec!/2","type":"function"},{"doc":"Fetches all rows using a statement.Should be called after the statement has been bound.Parametersstatement - The statement to run.Also accepts the following keyword options:into - The collection to put each row into. If provided, values are ziped with the column names, so into: %{} produces a Map (note that column names are Strings, not atoms). Defaults to nil which simply outputs each row as a list of values without any column names.atomic_names - Whether column names should be output as atoms instead of strings. Only has an effect when into is also given since otherwise no column names are output at all. If true, the output might look like [%{foo: 1, bar: 2}] instead of [%{&quot;foo&quot; =&gt; 1, &quot;bar&quot; =&gt; 2}] (with into: %{}). Defaults to false.db_timeout - The time in ms allowed for each sqlite3 command to run. Defaults to 5000 ms, or the :db_timeout value in application config. Note that the actual timeout may be many times larger because the timeout is applied to each internal fetch call individually.db_chunk_size - The internal bulk size (rows are fetched in bulks with each individual fetch call having a timeout of db_timeout). Defaults to 5000, or the :db_chunk_size value in the application config.Returns{:ok, results} on success{:error, {type, reason}} for any errors (see Sqlcx.error/0).","ref":"Sqlcx.Statement.html#fetch_all/2","title":"Sqlcx.Statement.fetch_all/2","type":"function"},{"doc":"Same as fetch_all/2 but raises a Sqlcx.Statement.FetchError on error.Returns the results otherwise.","ref":"Sqlcx.Statement.html#fetch_all!/2","title":"Sqlcx.Statement.fetch_all!/2","type":"function"},{"doc":"Fetches a single row using a statement. See fetch_all/2 for parameters.Note that statements are not immutable objects! fetch_one will return subsequent rows if called on the same statement multiple times.","ref":"Sqlcx.Statement.html#fetch_one/2","title":"Sqlcx.Statement.fetch_one/2","type":"function"},{"doc":"Same as fetch_one/2 but raises a Sqlcx.Statement.FetchError on error.Returns the result otherwise.","ref":"Sqlcx.Statement.html#fetch_one!/2","title":"Sqlcx.Statement.fetch_one!/2","type":"function"},{"doc":"Prepare a Sqlcx.StatementParametersdb - The database to prepare the statement for.sql - The SQL of the statement to prepare.Also accepts the following keyword options:db_timeout – timeout in ms for the esqlcipher commands involved in preparing the statement and binding values to it. Defaults to 5000, or the :db_timeout application config value.Returns{:ok, statement} on success{:error, {type, reason}} for any errors (see t:Sqlcx.error()).","ref":"Sqlcx.Statement.html#prepare/3","title":"Sqlcx.Statement.prepare/3","type":"function"},{"doc":"Same as prepare/3 but raises a Sqlcx.Statement.PrepareError on error.Returns a new statement otherwise.","ref":"Sqlcx.Statement.html#prepare!/3","title":"Sqlcx.Statement.prepare!/3","type":"function"},{"doc":"prepare/3 an SQL statement and bind/3 values to it","ref":"Sqlcx.Statement.html#prepare_bind/4","title":"Sqlcx.Statement.prepare_bind/4","type":"function"},{"doc":"Same as prepare_bind/4 but raises an Sqlcx.Statement.PrepareError or Sqlcx.Statement.BindError on error.","ref":"Sqlcx.Statement.html#prepare_bind!/4","title":"Sqlcx.Statement.prepare_bind!/4","type":"function"},{"doc":"Reset the prepared statement back to its initial state.Once the statement has been reset, you can run it once more. By default, any values bound to the statement will be retained. Set clear_bindings' totrue' to change this.Parametersclear_bindings - Whether to clear values bound to the statementAlso accepts the following keyword options:db_timeout – timeout in ms for the reset command to run. Defaults to 5000, or the :db_timeout application config value.Returns{:ok, statement} on success{:error, {type, reason}} for any errors (see Sqlcx.error/0).","ref":"Sqlcx.Statement.html#reset/1","title":"Sqlcx.Statement.reset/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#reset/2","title":"Sqlcx.Statement.reset/2","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#reset/3","title":"Sqlcx.Statement.reset/3","type":"function"},{"doc":"Same as reset/3 but raises an Sqlcx.Statement.ResetError on error.","ref":"Sqlcx.Statement.html#reset!/1","title":"Sqlcx.Statement.reset!/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#reset!/2","title":"Sqlcx.Statement.reset!/2","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#reset!/3","title":"Sqlcx.Statement.reset!/3","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#t:bind_value/0","title":"Sqlcx.Statement.bind_value/0","type":"type"},{"doc":"","ref":"Sqlcx.Statement.html#t:exec_options/0","title":"Sqlcx.Statement.exec_options/0","type":"type"},{"doc":"","ref":"Sqlcx.Statement.html#t:fetch_options/1","title":"Sqlcx.Statement.fetch_options/1","type":"type"},{"doc":"","ref":"Sqlcx.Statement.html#t:prepare_options/0","title":"Sqlcx.Statement.prepare_options/0","type":"type"},{"doc":"","ref":"Sqlcx.Statement.html#t:sql_value/0","title":"Sqlcx.Statement.sql_value/0","type":"type"},{"doc":"","ref":"Sqlcx.Statement.html#t:statement/0","title":"Sqlcx.Statement.statement/0","type":"opaque"},{"doc":"","ref":"Sqlcx.Statement.html#t:t/0","title":"Sqlcx.Statement.t/0","type":"type"},{"doc":"","ref":"Sqlcx.OpenError.html","title":"Sqlcx.OpenError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.OpenError.html#message/1","title":"Sqlcx.OpenError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.QueryError.html","title":"Sqlcx.QueryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.QueryError.html#message/1","title":"Sqlcx.QueryError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.RekeyError.html","title":"Sqlcx.RekeyError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.RekeyError.html#message/1","title":"Sqlcx.RekeyError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.BindError.html","title":"Sqlcx.Statement.BindError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.BindError.html#message/1","title":"Sqlcx.Statement.BindError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.ExecError.html","title":"Sqlcx.Statement.ExecError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.ExecError.html#message/1","title":"Sqlcx.Statement.ExecError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.FetchError.html","title":"Sqlcx.Statement.FetchError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.FetchError.html#message/1","title":"Sqlcx.Statement.FetchError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.PrepareError.html","title":"Sqlcx.Statement.PrepareError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.PrepareError.html#message/1","title":"Sqlcx.Statement.PrepareError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.ResetError.html","title":"Sqlcx.Statement.ResetError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.ResetError.html#message/1","title":"Sqlcx.Statement.ResetError.message/1","type":"function"},{"doc":"Sqlcx (sqlcipher interface for Elixir)An Elixir wrapper around esqlcipher. The main aim here is to provide convenient usage of sqlcipher databases (encrypted SQLite).Important NoteThis is a fork of the 'regular' sqlite variant (sqlitex). It is not finished yet and lots of things might change later on. Proceed with care :)Updated to 1.0With the 1.0 release, we made just a single breaking change. Sqlcx.Query.query previously returned just the raw query results on success and {:error, reason} on failure. This has been bothering us for a while, so we changed it in 1.0 to return {:ok, results} on success and {:error, reason} on failure. This should make it easier to pattern match on. The Sqlcx.Query.query! function has kept its same functionality of returning bare results on success and raising an error on failure.UsageThe simple way to use Sqlcx is just to open a database and run a querySqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query(db, &quot;SELECT * FROM players ORDER BY id LIMIT 1&quot;) end) # =&gt; [[id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil]] Sqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query(db, &quot;SELECT * FROM players ORDER BY id LIMIT 1&quot;, into: %{}) end) # =&gt; [%{id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil}]Pass the bind option to bind parameterized queries.Sqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query( db, &quot;INSERT INTO players (name, created_at, updated_at) VALUES (?1, ?2, ?3, ?4)&quot;, bind: [&#39;Mikey&#39;, &#39;2012-10-14 05:46:28.318107&#39;, &#39;2013-09-06 22:29:36.610911&#39;] ) end) # =&gt; [[id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil]]If you want to keep the database open during the lifetime of your project you can use the Sqlcx.Server GenServer module.start_link takes an options [db_password: &quot;password&quot;] tuple; password can be nil.Here's a sample from a phoenix projects main supervisor definition.children = [ # Start the endpoint when the application starts worker(Golf.Endpoint, []), worker(Sqlcx.Server, [&quot;golf.db&quot;, [db_password: &quot;password&quot;, name: Gold.DB]]) ]Now that the GenServer is running you can make queries viaSqlcx.Server.query(Golf.DB, &quot;SELECT g.id, g.course_id, g.played_at, c.name AS course FROM games AS g INNER JOIN courses AS c ON g.course_id = c.id ORDER BY g.played_at DESC LIMIT 10&quot;)ConfigurationSqlcx uses the Erlang library esqlcipher which accepts a timeout parameter for almost all interactions with the database. The default value for this timeout is 5000 ms. Many functions in Sqlcx accept a :db_timeout option that is passed on to the esqlite calls and also defaults to 5000 ms. If required, this default value can be overridden globally with the following in your config.exs:config :sqlcx, db_timeout: 10_000 # or other positive integer number of msAnother esqlite parameter is :db_chunk_size. This is a count of rows to read from native sqlite and send to erlang process in one bulk. For example, consider a table mytable that has 1000 rows. We make the query to get all rows with db_chunk_size: 500 parameter:Sqlcx.query(db, &quot;select * from mytable&quot;, db_chunk_size: 500)in this case all rows will be passed from native sqlite OS thread to the erlang process in two passes. Each pass will contain 500 rows. This parameter decrease overhead of transmitting rows from native OS sqlite thread to the erlang process by chunking list of result rows. Please decrease this value if rows are heavy. Default value is 5000.If you’re in doubt what to do with this parameter, just leave it as is. The default value will be ok in almost all cases.config :sqlcx, db_chunk_size: 500 # if most of the database rows are heavyLooking for Ecto?An SQLCipher Ecto2 adapter is in the works but is not finished yet.","ref":"readme.html","title":"Sqlcx (sqlcipher interface for Elixir)","type":"extras"}]