sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[],"id":"readme","title":"Sqlcx (sqlcipher interface for Elixir)"}],"modules":[{"group":"","id":"Sqlcx","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:connection/0","id":"connection/0"},{"anchor":"t:encrypted_connection/0","id":"encrypted_connection/0"},{"anchor":"t:error/0","id":"error/0"},{"anchor":"t:open_encrypted_options/0","id":"open_encrypted_options/0"},{"anchor":"t:open_options/0","id":"open_options/0"},{"anchor":"t:open_plaintext_options/0","id":"open_plaintext_options/0"},{"anchor":"t:password/0","id":"password/0"},{"anchor":"t:plaintext_connection/0","id":"plaintext_connection/0"},{"anchor":"t:query_options/0","id":"query_options/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"changes/2","id":"changes/2"},{"anchor":"close/2","id":"close/2"},{"anchor":"exec/3","id":"exec/3"},{"anchor":"exec!/3","id":"exec!/3"},{"anchor":"is_db/1","id":"is_db/1"},{"anchor":"is_encrypted/1","id":"is_encrypted/1"},{"anchor":"is_plaintext/1","id":"is_plaintext/1"},{"anchor":"open/2","id":"open/2"},{"anchor":"open!/2","id":"open!/2"},{"anchor":"query/3","id":"query/3"},{"anchor":"query!/3","id":"query!/3"},{"anchor":"query_rows/3","id":"query_rows/3"},{"anchor":"query_rows!/3","id":"query_rows!/3"},{"anchor":"rekey/3","id":"rekey/3"},{"anchor":"rekey!/3","id":"rekey!/3"},{"anchor":"savepoint/2","id":"savepoint/2"},{"anchor":"set_update_hook/3","id":"set_update_hook/3"},{"anchor":"transaction/2","id":"transaction/2"},{"anchor":"with_db/3","id":"with_db/3"},{"anchor":"with_db!/3","id":"with_db!/3"},{"anchor":"with_savepoint/3","id":"with_savepoint/3"},{"anchor":"with_transaction/3","id":"with_transaction/3"}]}],"sections":[{"anchor":"module-basic-example","id":"Basic Example"},{"anchor":"module-configuration","id":"Configuration"}],"title":"Sqlcx"},{"group":"","id":"Sqlcx.Server","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:init_options/0","id":"init_options/0"},{"anchor":"t:query_options/0","id":"query_options/0"},{"anchor":"t:server_id/0","id":"server_id/0"},{"anchor":"t:server_options/0","id":"server_options/0"},{"anchor":"t:state/0","id":"state/0"},{"anchor":"t:timeout_options/0","id":"timeout_options/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"changes/2","id":"changes/2"},{"anchor":"child_spec/1","id":"child_spec/1"},{"anchor":"exec/3","id":"exec/3"},{"anchor":"init/1","id":"init/1"},{"anchor":"prepare/3","id":"prepare/3"},{"anchor":"query/3","id":"query/3"},{"anchor":"query_rows/3","id":"query_rows/3"},{"anchor":"rekey/3","id":"rekey/3"},{"anchor":"set_update_hook/3","id":"set_update_hook/3"},{"anchor":"start_link/2","id":"start_link/2"},{"anchor":"stop/1","id":"stop/1"}]}],"sections":[{"anchor":"module-unsupervised-example","id":"Unsupervised Example"},{"anchor":"module-supervised-example","id":"Supervised Example"}],"title":"Sqlcx.Server"},{"group":"","id":"Sqlcx.Server.StatementCache","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"new/2","id":"new/2"},{"anchor":"prepare/3","id":"prepare/3"}]}],"sections":[],"title":"Sqlcx.Server.StatementCache"},{"group":"","id":"Sqlcx.Statement","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:bind_value/0","id":"bind_value/0"},{"anchor":"t:exec_options/0","id":"exec_options/0"},{"anchor":"t:fetch_options/1","id":"fetch_options/1"},{"anchor":"t:prepare_options/0","id":"prepare_options/0"},{"anchor":"t:sql_value/0","id":"sql_value/0"},{"anchor":"t:statement/0","id":"statement/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"bind/3","id":"bind/3"},{"anchor":"bind!/3","id":"bind!/3"},{"anchor":"blob/1","id":"blob/1"},{"anchor":"exec/2","id":"exec/2"},{"anchor":"exec!/2","id":"exec!/2"},{"anchor":"fetch_all/2","id":"fetch_all/2"},{"anchor":"fetch_all!/2","id":"fetch_all!/2"},{"anchor":"fetch_one/2","id":"fetch_one/2"},{"anchor":"fetch_one!/2","id":"fetch_one!/2"},{"anchor":"prepare/3","id":"prepare/3"},{"anchor":"prepare!/3","id":"prepare!/3"},{"anchor":"prepare_bind/4","id":"prepare_bind/4"},{"anchor":"prepare_bind!/4","id":"prepare_bind!/4"},{"anchor":"reset/1","id":"reset/1"},{"anchor":"reset/2","id":"reset/2"},{"anchor":"reset/3","id":"reset/3"},{"anchor":"reset!/1","id":"reset!/1"},{"anchor":"reset!/2","id":"reset!/2"},{"anchor":"reset!/3","id":"reset!/3"}]}],"sections":[{"anchor":"module-example","id":"Example"},{"anchor":"module-returning-clause-support","id":"RETURNING Clause Support"}],"title":"Sqlcx.Statement"},{"group":"Exceptions","id":"Sqlcx.OpenError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.OpenError"},{"group":"Exceptions","id":"Sqlcx.QueryError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.QueryError"},{"group":"Exceptions","id":"Sqlcx.RekeyError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.RekeyError"},{"group":"Exceptions","id":"Sqlcx.Statement.BindError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.Statement.BindError"},{"group":"Exceptions","id":"Sqlcx.Statement.ExecError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.Statement.ExecError"},{"group":"Exceptions","id":"Sqlcx.Statement.FetchError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.Statement.FetchError"},{"group":"Exceptions","id":"Sqlcx.Statement.PrepareError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.Statement.PrepareError"},{"group":"Exceptions","id":"Sqlcx.Statement.ResetError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Sqlcx.Statement.ResetError"}],"tasks":[]}